/*
   test_track_target - test track_target and track_target_onerev subroutines.

   Jeff Bytof   1-May-2001 
*/

#include "SpiceUsr.h"
#include "SpiceZmc.h"
#include "SpiceZfc.h"

int main()
{

   #define  CENID  699 
   #define  TRGID  601
   #define  OBSID  -82
   #define  ROOM   10000
   #define  UTCBEG "2005-06-08T12:00:00"

   SpiceChar utcdoy  [24];
   SpiceChar etc     [24];

   SpiceInt  cenid;
   SpiceInt  obsid;
   SpiceInt  trgid;

   SpiceDouble  dec;
   SpiceDouble  etstart;
   SpiceDouble  etlist    [ROOM];
   SpiceDouble  orbpars   [10];
   SpiceDouble  poslist   [ROOM][3]; 
   SpiceDouble  ra; 
   SpiceDouble  range; 
   SpiceDouble  rectan    [3]; 

   SpiceInt     i;
   SpiceInt     npts; 

   /*
      Read metakernel and get spice kernels
   */

   furnsh_c ( "track_target.ker" );
  
   cenid = CENID;
   trgid = TRGID; 
   obsid = OBSID; 

   printf( "cenid = %d \n", cenid );
   printf( "trgid = %d \n", trgid );
   printf( "obsid = %d \n", obsid );

   utc2et_c ( UTCBEG, &etstart );
   npts    = 100;

   printf ( "npts = %d \n", npts );
 
   printf("etstart = %lf \n", etstart);

   track_target_onerev ( cenid, 
                         trgid,
                         obsid,
                         etstart,
                         npts,
                         etlist,
                         poslist,
                         orbpars ); 

   printf("after , npts = %d\n", npts);

   for ( i=0; i<npts; i++ ) 
   {
      et2utc_c ( etlist[i], "D", (SpiceInt) 3, (SpiceInt) 24, utcdoy ); 
      etcal_c ( etlist[i], (SpiceInt) 24, etc );
      printf("et = %f  utc = %s etc = %s \npos = %f %f %f \n", 
              etlist[i],  utcdoy, etc,  
              poslist[i][0], poslist[i][1], poslist[i][2] );
      vpack_c ( poslist[i][0], poslist[i][1], poslist[i][2], rectan );
      recrad_c ( rectan, &range, &ra, &dec );
      ra = ra * dpr_c();
      dec = dec * dpr_c();
      printf("ra = %f   dec = %f \n\n", ra, dec );
   }


   printf("\ntarget body orbital elements\n");

   for ( i=0; i<10; i++ ) {
      printf("orbpars[%d] = %lf \n", i, orbpars[i]);
   }

   exit(0);
}
